#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <sys/soundcard.h>
#include <sys/fcntl.h>
#include <limits.h>
#include <sys/time.h>

/* Copyright (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/) *
 * No warranty. License: see file COPYING.                  */

// hisaxctrl HiSax 11 0xC00
// NECESSARY!

static const char cachefile[] = "/var/run/hepulicache";
static const char datadir[]   = "/etc/hepuli";
static const char configfile[]= "/etc/hepuli.conf";
static const char logfile[]   = "/var/log/hepulilog";

static int UseDoor=1;
static int UseLeds=1;

#define DEBUG 0

static char TUNTEMATON[] = "d_unknown";

static const char *arg0;
static int i;

static int sanottu=0;

FILE *log;

#include "leds.h"
#include "main.h"
#include "door.h"

static void Sano(const char *fn)
{
	int size;
	char buf[131072];
	FILE *fp1, *fp2;
	fp2 = fopen(cachefile, "rb+");
	if(!fp2)
	{
		fp2 = fopen(cachefile, "wb");
		if(!fp2)return;
	}
	sprintf(buf, "%s/%s", datadir, fn);
	fp1 = fopen(buf, "rb");
	if(!fp1){fclose(fp2);return;}
	
	fseek(fp2, sanottu, SEEK_SET);
	fseek(fp1, 0, SEEK_END);
	size = ftell(fp1);
	fseek(fp1, 0, SEEK_SET);
	fread(buf, 1, size, fp1);
	fwrite(buf, 1, size, fp2);
	fclose(fp1);
	fclose(fp2);
	sanottu += size;
}

static void FlushaaSanomus(void)
{
#if 1
	char Buf[128];
	sprintf(Buf, "/usr/local/bin/esdcat -m -r 27000 %s >/dev/null 2>&1", cachefile);
	if(!system(Buf))sanottu=0;
		
	if(!sanottu)unlink(cachefile);
		
#else
	unsigned char *buf;

	int out_sock, fd1;
	int out_rate = 27000;
	esd_format_t out_format = ESD_BITS16 | ESD_MONO | ESD_STREAM | ESD_PLAY;
	
	fd1 = open(cachefile, O_RDONLY);
	if(fd1 < 0)return;
	
	out_sock = esd_play_stream_fallback(out_format, out_rate, "127.0.0.1", NULL);
	if(out_sock <= 0)
	{
		printf("ESD error?\n");
		close(fd1);
		return;
	}

	buf = (unsigned char *)malloc(sanottu);
	read(fd1, buf, sanottu);
	write(out_sock, buf, sanottu);
	sanottu=0;
	free(buf);
	
	close(fd1);
	close(out_sock);
#endif
}

static void SanoNumero(char *dest, char *s)
{
	char Buf[256];
	int i = strlen(s);
	FILE *fp = fopen(configfile, "rt");
	if(!fp){if(dest)strcpy(dest, "*ERROR*");return;}
	while(fgets(Buf, sizeof Buf, fp))
		if(!strncmp(Buf, s, i) && Buf[i]=='\t')goto P1;
	s = TUNTEMATON;
	goto P2;
P1:
	s = Buf+i;
	while(*s=='\t')s++;
	i=strlen(s);
	while(i && (s[i-1]=='\n' || s[i-1]=='\r'))s[--i]=0;
P2:	if(dest)strcpy(dest, s);
	Sano(s);
	fclose(fp);
}

static int InvTrap(const char *s, int l, const char *f)
{
	fprintf(stderr, 
		"\n%s: Error %d (%s) at line %d in %s\nThis failed: %s\n",
		arg0, errno, sys_errlist[errno], l, f, s);
	exit(-1);
}
#define Trap(eq) (((i=(eq))<0)?InvTrap(#eq,__LINE__,__FILE__):i)

FILE *fp;

const char *kello(void)
{
	time_t tmp;
	struct tm *TM;
	static char buf[64];
	
	time(&tmp);
	TM = localtime(&tmp);
	strftime(buf, sizeof buf, "%d.%m.%Y %H:%M:%S", TM);
	return buf;
}

/* Reads one line from fp */
static void Reader(void)
{
	char Buf[256];
	
	fgets(Buf, sizeof Buf, fp);
	
	if(Buf[2] != ':'
	&& Buf[3] != ':') /* This is what we care about */
	{
		static char num1[42] = "0";
		static char num2[20];
		static int Mode=0;
		char Kohde[64], KohdeBuf[64];
		char *s, *dest;
		int a;
		
		if((Buf[0]==' ' || strstr(Buf, "message type"))
		&& !strstr(Buf, "octet"))
		{
//			if(log)fprintf(log, "%s", Buf);
		}
		
		if(strstr(Buf, "Calling party"))
		{
//			if(log)fprintf(log, "%s", Buf);
			Mode=0;
			return;
		}
		if(strstr(Buf, "Called party"))
		{
//			if(log)fprintf(log, "%s", Buf);
			Mode=1;
			return;
		}
		if(!strstr(Buf, "number digits"))return;
//		if(log)fprintf(log, "%s", Buf);
		
		s = strstr(Buf, "ts") + 3;
		dest = Mode?num2:num1;
		for(a=0; (*s!=' ')&&(*s!='\n')&&(*s!='\r'); dest[a++]=*s++);
		dest[a]=0;
		
		if(!Mode)return;
		
		KohdeBuf[0] = 0;
		
		Sano("d_RING");
		Sano("d_soittajaon");
//		Mukaan=1;
		SanoNumero(KohdeBuf, num1);
		
#if 0
		if(!strcmp(KohdeBuf, TUNTEMATON))
		{
			Sano("d_elinumero");
			s=num1;
			if(!strncmp(s, "0400", 4))Sano("d_0400"), s+=4;
			else if(!strncmp(s, "040", 3))Sano("d_040"), s+=3;
			else if(!strncmp(s, "050", 3))Sano("d_050"), s+=3;
			else if(!strncmp(s, "09", 2))Sano("d_09"), s+=2;
			else if(!strncmp(s, "02", 2))Sano("d_02"), s+=2;
			for(; *s; s++)
			{
				char buf[64];
				sprintf(buf, "d_%c", *s);
				Sano(buf);
			}
		}
		Sano("d_toistan"); SanoNumero(NULL, num1);
SkipPuhu:
#endif

		if(KohdeBuf[0])
		{
			char *q, *s = KohdeBuf;
			if(s[0]=='d' && s[1]=='_')s+=2;
			if((q=strstr(s, ".au"))!=NULL)*q=0;
			sprintf(Kohde, " (%s)", s);
		}
		else
			Kohde[0] = 0;
//		Mukaan=0;                                                                                                            
			
		printf("%-22s %20s%s", kello(), num1, Kohde);
		if(log)fprintf(log,  "%-22s %20s%s", kello(), num1, Kohde);
		sprintf(Kohde, "%%%ds.\r\n", 24-strlen(Kohde));
		printf(Kohde, num2);
		if(log)
			fprintf(log, Kohde, num2);
			
		FlushaaSanomus();
	
		strcpy(num1, "0");
	}
}

static void Main(void)
{
	fd_set fd;
	int timer=0;
	
#if DEBUG
	Trap(((fp=fopen("tmptmp", "rb"))==NULL)?-1:0);
#else
	Trap(((fp=fopen("/dev/isdnctrl", "rb"))==NULL)?-1:0);
	//fcntl(fileno(fp), F_SETFL, fcntl(fileno(fp), F_GETFL));
#endif

	printf("\r\n"
		"%-22s %20s%24s\r\n"
		"---------------------------------------------------------------------\r\n",
		"Soitot, kello", "Mist", "Mihin");
	
	{
	    char Buf[128];
    	sprintf(Buf, "grep ..\\\\...\\\\..... %s|tail -n 43", logfile);
    	system(Buf);
    	printf("\33[m\r"
    		"------------------------\n"
    		"Puhelinvakooja asennettu\n");
    }
    
    if(UseDoor)DoorInit();
    
	for(;;)
	{
		struct timeval tout = {0,1000};
		FD_ZERO(&fd);
		FD_SET(fileno(fp), &fd);
		
		switch(select(fileno(fp)+1, &fd, NULL, NULL, &tout))
		{
			case 0:
			{
				if(UseDoor)DoorCheck();
				if(!timer)
				{
					/* timeout */
					if(UseLeds)UpdLeds();
					timer=30;
				}
				else
					timer--;
				break;
			}
			case -1:
				break; /* error */
			default:
				if(FD_ISSET(fileno(fp), &fd))
				{
					Reader();
					if(log)fflush(log);
				}
		}
	}
}

int main(int argc, const char **argv)
{
	char *s, Host[256];
	
	log = fopen("/proc/sys/kernel/hostname", "rt");
	if(log)
	{
		fgets(Host, 255, log);
		s = strchr(Host, '\n'); if(s)*s = 0;
		s = strchr(Host, '\r'); if(s)*s = 0;
		fclose(log);
	}
	else
		Host[0] = 0; 
	
	argc = argc;	
	arg0 = argv[0];
	
	if(!Host[0])strcpy(Host, "unknown");
	
	log = fopen(logfile, "a");
	
	if(strcmp(Host, "proteus"))
	{
		UseDoor=0;
		UseLeds=0;/*
		if(log)
		{
			fprintf(log, "\33[m\r Started eternal loop on %s\n", Host);
			fflush(log);
		}
		for(;;)usleep(ULONG_MAX);*/
	}
	
	if(log)
	{
		setvbuf(log, NULL, _IONBF, 0);
		fprintf(log, "\33[m\r!! Restarted %s.\r\n\33[m\r", argv[0]);
		fflush(log);
	}
	
	close(0); /* stdin */
	
	setvbuf(stdout, NULL, _IONBF, 0);
	
	Main();
	
	if(log)fclose(log);
	return 0;
}
